/// <reference types="react" />
import * as React from 'react';
import { TextStyle, ViewStyle } from 'react-native';
export interface AlertMessageProps {
    title?: string;
    message?: string;
    icon?: string;
    allowClose?: boolean;
    isLoading?: boolean;
    style?: ViewStyle;
    iconStyle?: TextStyle;
    titleStyle?: TextStyle;
    textStyle?: TextStyle;
    type?: 'default' | 'primary' | 'danger' | 'warning' | 'info' | 'success';
}
export interface State {
    isVisible: boolean;
}
export default class AlertMessage extends React.Component<AlertMessageProps, State> {
    state: {
        isVisible: boolean;
    };
    close(): void;
    render(): JSX.Element | null;
}
