"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var View_1 = require("./View");
var Text_1 = require("./Text");
var Theme_1 = require("../../modules/theme/Theme");
var Icon_1 = require("./Icon");
var Touchable_1 = require("./Touchable");
var Loading_1 = require("./Loading");
var AlertMessage = (function (_super) {
    __extends(AlertMessage, _super);
    function AlertMessage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isVisible: true
        };
        return _this;
    }
    AlertMessage.prototype.close = function () {
        this.setState({ isVisible: false });
    };
    AlertMessage.prototype.render = function () {
        var _a = this.props, message = _a.message, isLoading = _a.isLoading, icon = _a.icon, allowClose = _a.allowClose, iconStyle = _a.iconStyle, textStyle = _a.textStyle, title = _a.title, titleStyle = _a.titleStyle, type = _a.type, style = _a.style;
        var isVisible = this.state.isVisible;
        if (!isVisible) {
            return null;
        }
        var typeContainerStyle = null;
        var typeIconColor = '';
        var typeTitleStyle = null;
        var typeTextStyle = null;
        switch (type) {
            case 'default':
            default:
                typeIconColor = Theme_1.default.vars.alertMessageDefaultIconColor;
                break;
            case 'primary':
                typeContainerStyle = styles.containerPrimary;
                typeIconColor = Theme_1.default.vars.alertMessagePrimaryIconColor;
                typeTextStyle = styles.textPrimary;
                typeTitleStyle = styles.titlePrimary;
                break;
            case 'danger':
                typeContainerStyle = styles.containerDanger;
                typeIconColor = Theme_1.default.vars.alertMessageDangerIconColor;
                typeTextStyle = styles.textDanger;
                typeTitleStyle = styles.titleDanger;
                break;
            case 'warning':
                typeContainerStyle = styles.containerWarning;
                typeIconColor = Theme_1.default.vars.alertMessageWarningIconColor;
                typeTextStyle = styles.textWarning;
                typeTitleStyle = styles.titleWarning;
                break;
            case 'info':
                typeContainerStyle = styles.containerInfo;
                typeIconColor = Theme_1.default.vars.alertMessageInfoIconColor;
                typeTextStyle = styles.textInfo;
                typeTitleStyle = styles.titleInfo;
                break;
            case 'success':
                typeContainerStyle = styles.containerSuccess;
                typeIconColor = Theme_1.default.vars.alertMessageSuccessIconColor;
                typeTextStyle = styles.textSuccess;
                typeTitleStyle = styles.titleSuccess;
                break;
        }
        var sizeIcon = 30;
        return (React.createElement(View_1.default, { style: [styles.container, typeContainerStyle, style] },
            isLoading &&
                React.createElement(Loading_1.default, { style: [styles.icon], color: typeIconColor, size: sizeIcon }),
            icon &&
                !isLoading &&
                React.createElement(Icon_1.default, { style: [styles.icon, { color: typeIconColor }, iconStyle], name: icon, size: sizeIcon }),
            React.createElement(View_1.default, { style: styles.alert },
                title &&
                    React.createElement(Text_1.default, { style: [styles.title, typeTitleStyle, titleStyle] }, title),
                message &&
                    React.createElement(Text_1.default, { style: [styles.text, typeTextStyle, textStyle] }, message)),
            allowClose &&
                React.createElement(Touchable_1.default, { onPress: this.close.bind(this) },
                    React.createElement(Icon_1.default, { style: [styles.icon, { color: typeIconColor }, iconStyle], name: 'close', size: 15 }))));
    };
    return AlertMessage;
}(React.Component));
exports.default = AlertMessage;
var styles = react_native_1.StyleSheet.create({
    icon: {
        marginRight: 6
    },
    container: {
        marginTop: 4,
        marginBottom: 4,
        backgroundColor: Theme_1.default.vars.alertMessageDefaultBackgroundColor,
        borderRadius: 4,
        padding: 10,
        flexDirection: 'row',
        alignItems: 'center'
    },
    containerPrimary: {
        backgroundColor: Theme_1.default.vars.alertMessagePrimaryBackgroundColor
    },
    containerDanger: {
        backgroundColor: Theme_1.default.vars.alertMessageDangerBackgroundColor
    },
    containerWarning: {
        backgroundColor: Theme_1.default.vars.alertMessageWarningBackgroundColor
    },
    containerInfo: {
        backgroundColor: Theme_1.default.vars.alertMessageInfoBackgroundColor
    },
    containerSuccess: {
        backgroundColor: Theme_1.default.vars.alertMessageSuccessBackgroundColor
    },
    alert: { flex: 1 },
    text: {
        fontSize: 13,
        color: Theme_1.default.vars.alertMessageDefaultTextColor
    },
    textPrimary: {
        color: Theme_1.default.vars.alertMessagePrimaryTextColor
    },
    textDanger: {
        color: Theme_1.default.vars.alertMessageDangerTextColor
    },
    textWarning: {
        color: Theme_1.default.vars.alertMessageSuccessTextColor
    },
    textInfo: {
        color: Theme_1.default.vars.alertMessageSuccessTextColor
    },
    textSuccess: {
        color: Theme_1.default.vars.alertMessageSuccessTextColor
    },
    title: {
        fontSize: 15,
        color: Theme_1.default.vars.alertMessageDefaultTitleColor
    },
    titlePrimary: {
        color: Theme_1.default.vars.alertMessagePrimaryTitleColor
    },
    titleDanger: {
        color: Theme_1.default.vars.alertMessageDangerTitleColor
    },
    titleWarning: {
        color: Theme_1.default.vars.alertMessageSuccessTitleColor
    },
    titleInfo: {
        color: Theme_1.default.vars.alertMessageSuccessTitleColor
    },
    titleSuccess: {
        color: Theme_1.default.vars.alertMessageSuccessTitleColor
    }
});
