"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Text_1 = require("./Text");
var Loading_1 = require("./Loading");
var Icon_1 = require("./Icon");
var Touchable_1 = require("./Touchable");
var View_1 = require("./View");
var Theme_1 = require("../../modules/theme/Theme");
var Button = (function (_super) {
    __extends(Button, _super);
    function Button() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Button.prototype.render = function () {
        var _a = this.props, children = _a.children, type = _a.type, iconStyle = _a.iconStyle, iconPosition = _a.iconPosition, icon = _a.icon, size = _a.size, style = _a.style, isLoading = _a.isLoading, textStyle = _a.textStyle, title = _a.title, props = __rest(_a, ["children", "type", "iconStyle", "iconPosition", "icon", "size", "style", "isLoading", "textStyle", "title"]);
        iconPosition = iconPosition || 'before';
        var typeContainerStyle = null;
        var typeIconColor = '';
        var typeTitleStyle = null;
        var sizeContainer = 0;
        var sizeIcon = 0;
        var sizeTitle = 0;
        switch (size) {
            case 'default':
            default:
                sizeContainer = 10;
                sizeIcon = 15;
                sizeTitle = 13;
                break;
            case 'small':
                sizeContainer = 8;
                sizeIcon = 13;
                sizeTitle = 11;
                break;
            case 'medium':
                sizeContainer = 20;
                sizeIcon = 18;
                sizeTitle = 16;
                break;
            case 'large':
                sizeContainer = 20;
                sizeIcon = 22;
                sizeTitle = 20;
                break;
        }
        switch (type) {
            case 'default':
            default:
                typeIconColor = Theme_1.default.vars.buttonDefaultIconColor;
                break;
            case 'primary':
                typeContainerStyle = styles.containerPrimary;
                typeIconColor = Theme_1.default.vars.buttonPrimaryIconColor;
                typeTitleStyle = styles.titlePrimary;
                break;
            case 'danger':
                typeContainerStyle = styles.containerDanger;
                typeIconColor = Theme_1.default.vars.buttonDangerIconColor;
                typeTitleStyle = styles.titleDanger;
                break;
            case 'warning':
                typeContainerStyle = styles.containerWarning;
                typeIconColor = Theme_1.default.vars.buttonWarningIconColor;
                typeTitleStyle = styles.titleWarning;
                break;
            case 'info':
                typeContainerStyle = styles.containerInfo;
                typeIconColor = Theme_1.default.vars.buttonInfoIconColor;
                typeTitleStyle = styles.titleInfo;
                break;
            case 'success':
                typeContainerStyle = styles.containerSuccess;
                typeIconColor = Theme_1.default.vars.buttonSuccessIconColor;
                typeTitleStyle = styles.titleSuccess;
                break;
        }
        return (React.createElement(Touchable_1.default, __assign({ style: [
                styles.container,
                { padding: sizeContainer },
                typeContainerStyle,
                style
            ] }, props),
            React.createElement(View_1.default, { style: styles.content },
                iconPosition === 'before' &&
                    isLoading &&
                    React.createElement(Loading_1.default, { style: [styles.iconBefore], color: typeIconColor, size: sizeIcon }),
                iconPosition === 'before' &&
                    icon &&
                    !isLoading &&
                    React.createElement(Icon_1.default, { style: [styles.iconBefore, { color: typeIconColor }, iconStyle], name: icon, size: sizeIcon }),
                title &&
                    React.createElement(Text_1.default, { style: [
                            styles.title,
                            { fontSize: sizeTitle },
                            typeTitleStyle,
                            textStyle
                        ] }, title),
                iconPosition === 'after' &&
                    isLoading &&
                    React.createElement(Loading_1.default, { style: [styles.iconAfter], color: typeIconColor, size: sizeIcon }),
                iconPosition === 'after' &&
                    icon &&
                    !isLoading &&
                    React.createElement(Icon_1.default, { style: [styles.iconAfter, { color: typeIconColor }, iconStyle], name: icon, size: sizeIcon }))));
    };
    return Button;
}(React.Component));
exports.default = Button;
var styles = react_native_1.StyleSheet.create({
    content: {
        //flex: 1,
        alignItems: 'center',
        flexDirection: 'row',
        justifyContent: 'center'
    },
    container: {
        backgroundColor: Theme_1.default.vars.buttonDefaultBackgroundColor,
        borderRadius: 4,
        margin: 2,
        alignItems: 'center',
        alignSelf: 'center',
        flexDirection: 'row',
        padding: 10,
        elevation: 1,
        shadowColor: Theme_1.default.vars.buttonDefaultShadowColor,
        shadowOffset: { height: 1, width: 0 },
        shadowOpacity: 0.2,
        shadowRadius: 4
    },
    containerPrimary: {
        backgroundColor: Theme_1.default.vars.buttonPrimaryBackgroundColor,
        shadowColor: Theme_1.default.vars.buttonPrimaryShadowColor
    },
    containerDanger: {
        backgroundColor: Theme_1.default.vars.buttonDangerBackgroundColor,
        shadowColor: Theme_1.default.vars.buttonDangerShadowColor
    },
    containerWarning: {
        backgroundColor: Theme_1.default.vars.buttonWarningBackgroundColor,
        shadowColor: Theme_1.default.vars.buttonWarningShadowColor
    },
    containerInfo: {
        backgroundColor: Theme_1.default.vars.buttonInfoBackgroundColor,
        shadowColor: Theme_1.default.vars.buttonInfoShadowColor
    },
    containerSuccess: {
        backgroundColor: Theme_1.default.vars.buttonSuccessBackgroundColor,
        shadowColor: Theme_1.default.vars.buttonSuccessShadowColor
    },
    title: {
        color: Theme_1.default.vars.buttonDefaultTextColor,
        // fontWeight: '500',
        fontSize: 13
    },
    titlePrimary: {
        color: Theme_1.default.vars.buttonPrimaryTextColor
    },
    titleDanger: {
        color: Theme_1.default.vars.buttonDangerTextColor
    },
    titleWarning: {
        color: Theme_1.default.vars.buttonSuccessTextColor
    },
    titleInfo: {
        color: Theme_1.default.vars.buttonSuccessTextColor
    },
    titleSuccess: {
        color: Theme_1.default.vars.buttonSuccessTextColor
    },
    iconBefore: {
        marginRight: 6
    },
    iconAfter: {
        marginLeft: 6
    }
});
