"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var DrawerTablet_1 = require("./DrawerTablet");
var View_1 = require("./View");
var Theme_1 = require("../../modules/theme/Theme");
var PropTypes = require('prop-types');
var DrawerAndroid = (function (_super) {
    __extends(DrawerAndroid, _super);
    function DrawerAndroid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpen: false,
            width: 0,
            height: 0
        };
        return _this;
    }
    DrawerAndroid.prototype.getChildContext = function () {
        return {
            drawer: {
                toggle: this.toggle.bind(this),
                close: this.close.bind(this),
                isOpen: this.isOpen.bind(this)
            }
        };
    };
    DrawerAndroid.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.onDimensionsChange;
                        return [4 /*yield*/, Screen_1.default.updateDimensions()];
                    case 1:
                        _a.apply(this, [_b.sent()]);
                        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
                        return [2 /*return*/];
                }
            });
        });
    };
    DrawerAndroid.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
    };
    DrawerAndroid.prototype.onDimensionsChange = function (dimensions) {
        this.setState({
            width: dimensions.width
        });
    };
    DrawerAndroid.prototype.isOpen = function () {
        return this.state.isOpen;
    };
    DrawerAndroid.prototype.toggle = function () {
        if (this.state.isOpen) {
            this.close();
        }
        else {
            this.open();
        }
    };
    DrawerAndroid.prototype.close = function () {
        this.refs.drawer && this.refs.drawer.closeDrawer();
    };
    DrawerAndroid.prototype.open = function () {
        this.refs.drawer && this.refs.drawer.openDrawer();
    };
    DrawerAndroid.prototype.onDrawerClose = function () {
        this.setState({ isOpen: false });
        if (this.props.onCloseStart) {
            this.props.onCloseStart();
        }
    };
    DrawerAndroid.prototype.onDrawerOpen = function () {
        this.setState({ isOpen: true });
        if (this.props.onOpenStart) {
            this.props.onOpenStart();
        }
    };
    DrawerAndroid.prototype.render = function () {
        var _a = this.state, width = _a.width, height = _a.height;
        if (width < 1) {
            return null;
        }
        var _b = this.props, tabledModeMinWidth = _b.tabledModeMinWidth, tabletContent = _b.tabletContent, content = _b.content, children = _b.children, useTabledMode = _b.useTabledMode, props = __rest(_b, ["tabledModeMinWidth", "tabletContent", "content", "children", "useTabledMode"]);
        var containerWidth = width || 300;
        var maxWidth = containerWidth > 360 ? 360 : containerWidth;
        maxWidth *= containerWidth < 250 ? 0.9 : 0.8;
        var minWidthTabled = tabledModeMinWidth || 800;
        if (width > minWidthTabled && useTabledMode) {
            return (React.createElement(DrawerTablet_1.default, __assign({ leftStyle: { width: maxWidth }, content: tabletContent ? tabletContent : content }, this.props)));
        }
        return (React.createElement(react_native_1.DrawerLayoutAndroid, { ref: 'drawer', drawerWidth: maxWidth, onDrawerOpen: this.onDrawerOpen.bind(this), onDrawerClose: this.onDrawerClose.bind(this), drawerPosition: react_native_1.DrawerLayoutAndroid.positions.Left, renderNavigationView: function () { return content; } },
            React.createElement(View_1.default, { style: styles.content }, children)));
    };
    return DrawerAndroid;
}(React.Component));
DrawerAndroid.childContextTypes = {
    drawer: PropTypes.object
};
exports.default = DrawerAndroid;
var styles = react_native_1.StyleSheet.create({
    content: {
        flex: 1,
        backgroundColor: Theme_1.default.vars.drawerContentBackgroundColor
    }
});
