"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var View_1 = require("./View");
var Icon_1 = require("./Icon");
var Text_1 = require("./Text");
var Translator_1 = require("../../modules/i18n/Translator");
var Theme_1 = require("../../modules/theme/Theme");
var DrawerFooter = (function (_super) {
    __extends(DrawerFooter, _super);
    function DrawerFooter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DrawerFooter.prototype.render = function () {
        var _a = this.props, style = _a.style, text = _a.text, icon = _a.icon, iconStyle = _a.iconStyle, textStyle = _a.textStyle, props = __rest(_a, ["style", "text", "icon", "iconStyle", "textStyle"]);
        return (React.createElement(View_1.default, __assign({ style: [styles.container, style] }, props),
            React.createElement(View_1.default, { style: styles.labelContainer },
                icon &&
                    React.createElement(Icon_1.default, { name: icon, style: [styles.icon, iconStyle], size: 25 }),
                typeof icon === 'undefined' &&
                    React.createElement(Icon_1.default, { name: 'copyright', style: [styles.icon, iconStyle], size: 25 }),
                React.createElement(Text_1.default, { style: [styles.label, textStyle] }, text || Translator_1._('{app} - All rights reserved', { app: 'React Suite' })))));
    };
    return DrawerFooter;
}(React.Component));
exports.default = DrawerFooter;
var styles = react_native_1.StyleSheet.create({
    container: {
        borderTopWidth: 1,
        borderTopColor: Theme_1.default.vars.drawerFooterBorderColor,
        padding: 12,
        paddingLeft: 10,
        paddingRight: 10,
        flexDirection: 'row'
    },
    labelContainer: {
        flexDirection: 'row',
        alignItems: 'center',
        flex: 1
    },
    label: {
        textAlignVertical: 'center',
        marginLeft: 15,
        fontSize: 12,
        color: Theme_1.default.vars.drawerFooterTextColor
    },
    icon: {
        marginLeft: 5,
        color: Theme_1.default.vars.drawerFooterIconColor
    }
});
