"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var View_1 = require("./View");
var Text_1 = require("./Text");
var Touchable_1 = require("./Touchable");
var Icon_1 = require("./Icon");
var Theme_1 = require("../../modules/theme/Theme");
var DrawerItem = (function (_super) {
    __extends(DrawerItem, _super);
    function DrawerItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DrawerItem.prototype.render = function () {
        var _a = this.props, style = _a.style, name = _a.name, rightView = _a.rightView, icon = _a.icon, isActive = _a.isActive, isHeader = _a.isHeader, onPress = _a.onPress, headerStyle = _a.headerStyle, nameStyle = _a.nameStyle, iconStyle = _a.iconStyle, props = __rest(_a, ["style", "name", "rightView", "icon", "isActive", "isHeader", "onPress", "headerStyle", "nameStyle", "iconStyle"]);
        if (isHeader) {
            return (React.createElement(View_1.default, { style: [styles.headerContainer, style] },
                React.createElement(Text_1.default, { style: [styles.headerLabel, headerStyle] }, (name || '').toUpperCase())));
        }
        return (React.createElement(Touchable_1.default, { onPress: onPress },
            React.createElement(View_1.default, { style: [styles.container, isActive && styles.activeContainer, style] },
                icon &&
                    React.createElement(Icon_1.default, { name: icon, style: [styles.icon, isActive && styles.activeIcon, iconStyle], size: 25 }),
                React.createElement(Text_1.default, { style: [styles.label, isActive && styles.activeLabel, nameStyle] }, name),
                rightView)));
    };
    return DrawerItem;
}(React.Component));
exports.default = DrawerItem;
var styles = react_native_1.StyleSheet.create({
    headerContainer: {
        padding: 5,
        paddingLeft: 10,
        paddingTop: 10,
        borderBottomWidth: 1,
        borderBottomColor: Theme_1.default.vars.drawerItemHeaderBorderColor,
        flexDirection: 'row',
        alignItems: 'center'
    },
    headerLabel: {
        paddingLeft: 5,
        fontSize: 11,
        color: Theme_1.default.vars.drawerItemHeaderTextColor,
        fontWeight: '400',
        alignSelf: 'center'
    },
    activeContainer: {
        backgroundColor: Theme_1.default.vars.drawerItemActiveBackgroundColor
    },
    activeLabel: {
        color: Theme_1.default.vars.drawerItemActiveTextColor
    },
    activeIcon: {
        color: Theme_1.default.vars.drawerItemActiveIconColor
    },
    container: {
        padding: 10,
        paddingLeft: 10,
        flexDirection: 'row',
        alignItems: 'center'
    },
    label: {
        marginLeft: 13,
        fontSize: 13,
        flex: 1,
        color: Theme_1.default.vars.drawerItemTextColor,
        alignSelf: 'center'
    },
    icon: {
        marginLeft: 5,
        color: Theme_1.default.vars.drawerItemIconColor
    }
});
