/// <reference types="react" />
import * as React from 'react';
import { TextInput, ViewStyle } from 'react-native';
import { Dimensions } from '../../modules/listener/Screen';
export interface FilterProps {
    filterMargin?: number;
    placeholder?: string;
    style?: ViewStyle;
    onSubmitEditing?: (text: string) => void;
    onChange: (text: string) => void;
}
export interface State {
    text: string;
    inputWidth: number;
}
export default class Filter extends React.Component<FilterProps, State> {
    state: {
        text: string;
        inputWidth: number;
    };
    refs: {
        [string: string]: any;
        input: TextInput;
    };
    private changeListener;
    private onDimensionsChangeListener;
    onChange(text?: string): void;
    setQuery(text: string): void;
    clean(): void;
    onSubmitEditing(event: {
        nativeEvent: {
            text: string;
        };
    }): void;
    focus(): void;
    onDimensionsChange(dimensions: Dimensions): void;
    componentDidMount(): Promise<void>;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
