"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Icon_1 = require("./Icon");
var Touchable_1 = require("./Touchable");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var Translator_1 = require("../../modules/i18n/Translator");
var Filter = (function (_super) {
    __extends(Filter, _super);
    function Filter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            text: '',
            inputWidth: Screen_1.default.getDimensions().width
        };
        return _this;
    }
    Filter.prototype.onChange = function (text) {
        var _this = this;
        if (text === void 0) { text = ''; }
        text = text.trim();
        if (text === this.state.text) {
            return;
        }
        this.setState({ text: text });
        if (this.changeListener) {
            clearTimeout(this.changeListener);
        }
        this.changeListener = setTimeout(function () {
            if (typeof _this.props.onChange === 'function') {
                _this.props.onChange(text);
            }
        }, 100);
    };
    Filter.prototype.setQuery = function (text) {
        this.setState({ text: text });
    };
    Filter.prototype.clean = function () {
        this.setState({ text: '' });
        if (typeof this.props.onChange === 'function') {
            this.props.onChange('');
        }
    };
    Filter.prototype.onSubmitEditing = function (event) {
        if (typeof this.props.onSubmitEditing === 'function') {
            this.props.onSubmitEditing(event.nativeEvent.text);
        }
    };
    Filter.prototype.focus = function () {
        this.refs.input.focus();
    };
    Filter.prototype.onDimensionsChange = function (dimensions) {
        var inputWidth = dimensions.width - (this.props.filterMargin || 0) * 2;
        this.setState({ inputWidth: inputWidth });
    };
    Filter.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.onDimensionsChange;
                        return [4 /*yield*/, Screen_1.default.updateDimensions()];
                    case 1:
                        _a.apply(this, [_b.sent()]);
                        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
                        return [2 /*return*/];
                }
            });
        });
    };
    Filter.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.orientationListener);
    };
    Filter.prototype.render = function () {
        var _a = this.props, filterMargin = _a.filterMargin, style = _a.style, onChange = _a.onChange, placeholder = _a.placeholder, onSubmitEditing = _a.onSubmitEditing, props = __rest(_a, ["filterMargin", "style", "onChange", "placeholder", "onSubmitEditing"]);
        var _b = this.state, inputWidth = _b.inputWidth, text = _b.text;
        return (React.createElement(react_native_1.View, { style: [styles.container, { width: inputWidth }, style] },
            React.createElement(react_native_1.View, { style: styles.inputContainer },
                React.createElement(react_native_1.TextInput, __assign({ ref: 'input', style: [styles.input], placeholderTextColor: '#f4f4f4', placeholder: placeholder || Translator_1._('Filtrar'), returnKeyType: 'search', blurOnSubmit: true, onSubmitEditing: this.onSubmitEditing.bind(this), onChangeText: this.onChange.bind(this), value: text }, props)),
                React.createElement(react_native_1.View, { style: styles.search },
                    React.createElement(Icon_1.default, { name: 'search' })),
                React.createElement(react_native_1.View, { style: [styles.fixed] },
                    React.createElement(Touchable_1.default, { style: styles.cleanButton, onPress: this.clean.bind(this) },
                        React.createElement(react_native_1.View, { style: styles.clean },
                            React.createElement(Icon_1.default, { name: 'close' })))))));
    };
    return Filter;
}(React.Component));
exports.default = Filter;
var styles = react_native_1.StyleSheet.create({
    container: {},
    search: {
        paddingRight: 6,
        paddingTop: 4,
        paddingBottom: 6,
        paddingLeft: 4,
        position: 'absolute',
        left: 0,
        top: 0
    },
    searchIcon: {
        color: '#444',
        margin: 2
    },
    fixed: {
        position: 'absolute',
        right: 0,
        top: 0
    },
    icon: {
        color: '#fff',
        margin: 2
    },
    clean: {
        backgroundColor: '#f4f4f4',
        borderRadius: 24 / 2,
        height: 24,
        width: 24,
        overflow: 'hidden'
    },
    cleanButton: {
        paddingRight: 6,
        paddingTop: 4,
        paddingBottom: 4,
        paddingLeft: 6
    },
    inputContainer: {
        borderColor: '#f4f4f4',
        borderWidth: 1,
        backgroundColor: '#f9f9f9',
        borderRadius: 4,
        padding: 1
    },
    input: {
        height: 30,
        backgroundColor: 'blue',
        color: 'red',
        fontSize: 14,
        paddingTop: 0,
        paddingBottom: 0,
        paddingLeft: 30
    }
});
