/// <reference types="react" />
import * as React from 'react';
import ListView, { ListViewProps } from './ListView';
import { Dimensions } from '../../modules/listener/Screen';
import { LayoutChangeEvent } from 'react-native';
export interface FlexibleGridProps extends ListViewProps {
    itemMargin?: number;
    itemWidth: number;
}
export interface State {
    itemWidth: number;
    containerWidth: number;
    containerHeight: number;
}
export interface FlexibleGridItemStyle {
    margin: number;
    width: number;
}
export default class FlexibleGrid extends React.PureComponent<FlexibleGridProps, State> {
    state: {
        itemWidth: number;
        containerWidth: number;
        containerHeight: number;
    };
    refs: {
        [string: string]: any;
        list: ListView;
    };
    private onDimensionsChangeListener;
    onDimensionsChange(dimensions: Dimensions): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    renderRow(rowData: any, sectionID: string | number, rowID: string | number, highlightRow?: boolean): JSX.Element;
    refreshView(): void;
    onLayout(event: LayoutChangeEvent): void;
    render(): JSX.Element;
}
