"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ListView_1 = require("./ListView");
var View_1 = require("./View");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var react_native_1 = require("react-native");
var Log_1 = require("../../modules/logger/Log");
var FlexibleGrid = (function (_super) {
    __extends(FlexibleGrid, _super);
    function FlexibleGrid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            itemWidth: 0,
            containerWidth: 0,
            containerHeight: 0
        };
        return _this;
    }
    FlexibleGrid.prototype.onDimensionsChange = function (dimensions) {
        var _this = this;
        var width = dimensions.width;
        var _a = this.props, itemWidth = _a.itemWidth, itemMargin = _a.itemMargin;
        var containerWidth = this.state.containerWidth;
        if (!containerWidth) {
            return;
        }
        containerWidth = containerWidth || width;
        var cols = Math.floor(containerWidth / itemWidth);
        cols = cols < 1 ? 1 : cols;
        itemMargin = itemMargin || 0;
        var windowWidth = containerWidth - itemMargin * ((cols + 1) * 2);
        itemWidth = windowWidth / cols;
        this.setState({ itemWidth: itemWidth }, function () {
            _this.refs.list && _this.refs.list.refreshView();
        });
        Log_1.default.info('[FLEXIBLE-GRID]', 'onDimensionsChange', width, containerWidth, itemWidth, itemMargin);
    };
    FlexibleGrid.prototype.componentDidMount = function () {
        //
    };
    FlexibleGrid.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
    };
    FlexibleGrid.prototype.renderRow = function (rowData, sectionID, rowID, highlightRow) {
        var margin = this.props.itemMargin || 0;
        var width = 0;
        var itemWidth = this.state.itemWidth;
        if (itemWidth > 0) {
            width = itemWidth;
        }
        var customStyle = { margin: margin, width: width };
        return (React.createElement(View_1.default, { style: customStyle }, this.props.renderRow(rowData, sectionID, rowID, highlightRow, customStyle)));
    };
    FlexibleGrid.prototype.refreshView = function () {
        this.refs.list && this.refs.list.refreshView();
    };
    FlexibleGrid.prototype.onLayout = function (event) {
        var _this = this;
        var layout = event.nativeEvent.layout;
        Log_1.default.debug('[FLEXIBLE-GRID]', 'onLayout', layout);
        this.setState({
            containerWidth: layout.width,
            containerHeight: layout.height
        }, function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.onDimensionsChange(Screen_1.default.getDimensions());
                return [2 /*return*/];
            });
        }); });
        if (this.props.onLayout) {
            this.props.onLayout(event);
        }
    };
    FlexibleGrid.prototype.render = function () {
        var _a = this.props, renderRow = _a.renderRow, itemWidth = _a.itemWidth, itemMargin = _a.itemMargin, style = _a.style, props = __rest(_a, ["renderRow", "itemWidth", "itemMargin", "style"]);
        var itemWidthState = this.state.itemWidth;
        if (!itemWidthState) {
            return React.createElement(View_1.default, { ref: 'list', onLayout: this.onLayout.bind(this) });
        }
        return (React.createElement(ListView_1.default, __assign({}, props, { ref: 'list', style: style, contentContainerStyle: [
                styles.list,
                { padding: this.props.itemMargin }
            ], onLayout: this.onLayout.bind(this), renderRow: this.renderRow.bind(this) })));
    };
    return FlexibleGrid;
}(React.PureComponent));
exports.default = FlexibleGrid;
var styles = react_native_1.StyleSheet.create({
    list: {
        flexDirection: 'row',
        flexWrap: 'wrap',
        alignItems: 'flex-start'
    }
});
