"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var View_1 = require("./View");
var Text_1 = require("./Text");
var HeaderAction_1 = require("./HeaderAction");
var StatusBarView_1 = require("./StatusBarView");
var HeaderDrawerAction_1 = require("./HeaderDrawerAction");
var Theme_1 = require("../../modules/theme/Theme");
var PropTypes = require('prop-types');
var Header = (function (_super) {
    __extends(Header, _super);
    function Header() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Header.prototype.render = function () {
        var _a = this.props, statusBarBackgroundColor = _a.statusBarBackgroundColor, statusBarStyle = _a.statusBarStyle, maxWidth = _a.maxWidth, left = _a.left, right = _a.right, actions = _a.actions, title = _a.title;
        var maxWidthFinal = maxWidth || 900;
        var statusBarBackgroundColorFinal = statusBarBackgroundColor ||
            (react_native_1.Platform.OS === 'android'
                ? Theme_1.default.vars.statusBarViewBackgroundAndroidColor
                : Theme_1.default.vars.statusBarViewBackgroundIOSColor);
        var statusBarStyleFinal = statusBarStyle || (react_native_1.Platform.OS === 'android' ? 'default' : 'default');
        return (React.createElement(View_1.default, { style: styles.container },
            React.createElement(StatusBarView_1.default, { backgroundColor: statusBarBackgroundColorFinal, barStyle: statusBarStyleFinal }),
            React.createElement(View_1.default, { style: [styles.content] },
                React.createElement(View_1.default, { style: [styles.header, { maxWidth: maxWidthFinal }] },
                    left &&
                        React.createElement(View_1.default, { style: styles.left },
                            !('onPress' in left) && left,
                            'onPress' in left &&
                                React.createElement(HeaderAction_1.default, __assign({}, left))),
                    !left &&
                        React.createElement(View_1.default, { style: styles.left },
                            React.createElement(HeaderDrawerAction_1.default, { iconStyle: styles.icon, style: styles.buttonMenu })),
                    React.createElement(View_1.default, { style: styles.center },
                        typeof title === 'object' && title,
                        typeof title !== 'object' &&
                            React.createElement(Text_1.default, { style: styles.title, numberOfLines: 2 }, title)),
                    actions &&
                        actions.length > 0 &&
                        React.createElement(View_1.default, { style: styles.options }, actions.map(function (item, index) {
                            return React.createElement(HeaderAction_1.default, __assign({ key: index }, item));
                        })),
                    right &&
                        React.createElement(View_1.default, { style: styles.right },
                            !('onPress' in right) && right,
                            'onPress' in right &&
                                React.createElement(HeaderAction_1.default, __assign({}, right)))))));
    };
    return Header;
}(React.Component));
exports.default = Header;
var styles = react_native_1.StyleSheet.create({
    buttonMenu: {
        padding: 10,
        paddingLeft: 15
    },
    icon: {
        color: Theme_1.default.vars.headerIconColor
    },
    options: {
        flexDirection: 'row'
    },
    right: {
        flexDirection: 'row',
        justifyContent: 'flex-end'
    },
    left: {
        flexDirection: 'row',
        justifyContent: 'flex-start'
    },
    title: {
        fontSize: 16,
        color: Theme_1.default.vars.headerTextColor
    },
    center: {
        alignItems: 'flex-start',
        justifyContent: 'center',
        flex: 1
    },
    container: {
        backgroundColor: Theme_1.default.vars.headerBackgroundColor,
        //position: Platform.OS === 'web' ? 'fixed' : 'absolute',
        // position: 'absolute',
        zIndex: 1,
        flexDirection: 'column',
        elevation: 4,
        shadowColor: Theme_1.default.vars.headerShadowColor,
        shadowOpacity: 0.1,
        shadowRadius: 2,
        shadowOffset: {
            height: 1,
            width: 2
        }
    },
    content: {
        flexDirection: 'row',
        justifyContent: 'center'
    },
    header: {
        flex: 1,
        flexDirection: 'row',
        height: 60
    }
});
