/// <reference types="react" />
import * as React from 'react';
import { TextInput, TextInputProperties, ViewStyle } from 'react-native';
export interface InputProps extends TextInputProperties {
    value?: string;
    placeholder?: string;
    defaultValue?: string;
    hasError?: boolean;
    style?: ViewStyle;
    containerStyle?: ViewStyle;
    onChangeText?: (text: string) => void;
    useLabel?: boolean;
}
export interface State {
    value: string;
}
export default class Input extends React.Component<InputProps, State> {
    state: {
        value: string;
    };
    refs: {
        [string: string]: any;
        input: TextInput;
    };
    setValue(value: string): void;
    getValue(): string;
    focus(): void;
    onChangeText(text: string): void;
    componentDidMount(): void;
    render(): JSX.Element;
}
