"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Text_1 = require("./Text");
var Icon_1 = require("./Icon");
var Touchable_1 = require("./Touchable");
var View_1 = require("./View");
var Theme_1 = require("../../modules/theme/Theme");
var Label = (function (_super) {
    __extends(Label, _super);
    function Label() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Label.prototype.render = function () {
        var _a = this.props, children = _a.children, type = _a.type, style = _a.style, hideIcon = _a.hideIcon, textStyle = _a.textStyle, size = _a.size, title = _a.title, props = __rest(_a, ["children", "type", "style", "hideIcon", "textStyle", "size", "title"]);
        var typeContainerStyle = null;
        var typeIconColor = '';
        var typeTitleStyle = null;
        var sizeContainer = 0;
        var sizeIcon = 0;
        var sizeTitle = 0;
        switch (size) {
            case 'default':
            default:
                sizeContainer = 4;
                sizeIcon = 11;
                sizeTitle = 10;
                break;
            case 'small':
                sizeContainer = 4;
                sizeIcon = 12;
                sizeTitle = 11;
                break;
            case 'medium':
                sizeContainer = 6;
                sizeIcon = 13;
                sizeTitle = 12;
                break;
            case 'large':
                sizeContainer = 8;
                sizeIcon = 14;
                sizeTitle = 13;
                break;
        }
        switch (type) {
            case 'default':
            default:
                typeIconColor = Theme_1.default.vars.labelDefaultIconColor;
                break;
            case 'primary':
                typeContainerStyle = styles.containerPrimary;
                typeIconColor = Theme_1.default.vars.labelPrimaryIconColor;
                typeTitleStyle = styles.titlePrimary;
                break;
            case 'danger':
                typeContainerStyle = styles.containerDanger;
                typeIconColor = Theme_1.default.vars.labelDangerIconColor;
                typeTitleStyle = styles.titleDanger;
                break;
            case 'warning':
                typeContainerStyle = styles.containerWarning;
                typeIconColor = Theme_1.default.vars.labelWarningIconColor;
                typeTitleStyle = styles.titleWarning;
                break;
            case 'info':
                typeContainerStyle = styles.containerInfo;
                typeIconColor = Theme_1.default.vars.labelInfoIconColor;
                typeTitleStyle = styles.titleInfo;
                break;
            case 'success':
                typeContainerStyle = styles.containerSuccess;
                typeIconColor = Theme_1.default.vars.labelSuccessIconColor;
                typeTitleStyle = styles.titleSuccess;
                break;
        }
        return (React.createElement(Touchable_1.default, __assign({ style: [
                styles.container,
                { padding: sizeContainer },
                typeContainerStyle,
                style
            ] }, props),
            React.createElement(View_1.default, { style: styles.content },
                !hideIcon &&
                    React.createElement(Icon_1.default, { style: [styles.icon, { color: typeIconColor }], name: 'label', size: sizeIcon }),
                title &&
                    React.createElement(Text_1.default, { style: [
                            styles.title,
                            { fontSize: sizeTitle },
                            typeTitleStyle,
                            textStyle
                        ] }, title.toUpperCase()))));
    };
    return Label;
}(React.Component));
exports.default = Label;
var styles = react_native_1.StyleSheet.create({
    content: {
        //flex: 1,
        alignItems: 'center',
        flexDirection: 'row',
        justifyContent: 'center'
    },
    container: {
        backgroundColor: Theme_1.default.vars.labelDefaultBackgroundColor,
        borderRadius: 30,
        margin: 2,
        alignItems: 'center',
        alignSelf: 'center',
        flexDirection: 'row',
        padding: 4,
        paddingLeft: 8,
        paddingRight: 8
    },
    containerPrimary: {
        backgroundColor: Theme_1.default.vars.labelPrimaryBackgroundColor
    },
    containerDanger: {
        backgroundColor: Theme_1.default.vars.labelDangerBackgroundColor
    },
    containerWarning: {
        backgroundColor: Theme_1.default.vars.labelWarningBackgroundColor
    },
    containerInfo: {
        backgroundColor: Theme_1.default.vars.labelInfoBackgroundColor
    },
    containerSuccess: {
        backgroundColor: Theme_1.default.vars.labelSuccessBackgroundColor
    },
    title: {
        color: Theme_1.default.vars.labelDefaultTextColor,
        fontWeight: '500',
        fontSize: 12
    },
    titlePrimary: {
        color: Theme_1.default.vars.labelPrimaryTextColor
    },
    titleDanger: {
        color: Theme_1.default.vars.labelDangerTextColor
    },
    titleWarning: {
        color: Theme_1.default.vars.labelSuccessTextColor
    },
    titleInfo: {
        color: Theme_1.default.vars.labelSuccessTextColor
    },
    titleSuccess: {
        color: Theme_1.default.vars.labelSuccessTextColor
    },
    icon: {
        marginRight: 4
    }
});
