/// <reference types="react" />
import * as React from 'react';
import { LayoutChangeEvent, ListView as BaseListView, ListViewProperties, MeasureOnSuccessCallback, NativeScrollEvent, NativeSyntheticEvent, ScrollViewStyle, ViewStyle } from 'react-native';
export interface ListViewProps extends ListViewProperties {
    dataSource: any;
    renderRow: (rowData: any, sectionID: string | number, rowID: string | number, highlightRow?: boolean, extra?: any) => React.ReactElement<any>;
    renderHeader?: () => React.ReactElement<any>;
    renderFooter?: () => React.ReactElement<any>;
    onScroll?: (event?: NativeSyntheticEvent<NativeScrollEvent>) => void;
    contentContainerStyle?: ViewStyle;
    style?: ScrollViewStyle;
    onLayout?: (event: LayoutChangeEvent) => void;
}
export interface State {
}
export default class ListView extends React.Component<ListViewProps, State> {
    static DataSource: any;
    refs: {
        [string: string]: any;
        list: BaseListView;
    };
    refreshView(): void;
    measure(callback: MeasureOnSuccessCallback): void;
    render(): JSX.Element;
}
