"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var ScrollView_1 = require("./ScrollView");
var Log_1 = require("../../modules/logger/Log");
var View_1 = require("./View");
var DataSource = (function () {
    function DataSource(config) {
        this.data = [];
        Log_1.default.info('DataSource');
    }
    DataSource.prototype.cloneWithRows = function (results) {
        this.data = results;
        return this;
    };
    return DataSource;
}());
exports.DataSource = DataSource;
var ListViewWeb = (function (_super) {
    __extends(ListViewWeb, _super);
    function ListViewWeb() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ListViewWeb.prototype.refreshView = function () {
        this.forceUpdate();
    };
    ListViewWeb.prototype.render = function () {
        var _a = this.props, renderRow = _a.renderRow, onLayout = _a.onLayout, contentContainerStyle = _a.contentContainerStyle, style = _a.style, renderHeader = _a.renderHeader, dataSource = _a.dataSource, renderFooter = _a.renderFooter;
        return (React.createElement(ScrollView_1.default, { onLayout: onLayout, ref: 'listView', style: [styles.container, style] },
            React.createElement(View_1.default, { style: contentContainerStyle },
                renderHeader,
                dataSource &&
                    dataSource.data &&
                    dataSource.data.map(function (rowData, sectionID, rowID, highlightRow) {
                        return (React.createElement(View_1.default, { key: sectionID }, renderRow(rowData, 0, sectionID, false)));
                    }),
                renderFooter)));
    };
    return ListViewWeb;
}(React.Component));
ListViewWeb.DataSource = DataSource;
exports.default = ListViewWeb;
var styles = react_native_1.StyleSheet.create({
    container: {}
});
