"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var MessageItem_1 = require("./MessageItem");
var View_1 = require("./View");
var Log_1 = require("../../modules/logger/Log");
var MessageCenter = (function (_super) {
    __extends(MessageCenter, _super);
    function MessageCenter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            messages: []
        };
        return _this;
    }
    MessageCenter.prototype.show = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var messages, exist;
            return __generator(this, function (_a) {
                MessageCenter.counter++;
                if (!params.id) {
                    params.id = MessageCenter.counter.toString();
                }
                messages = this.state.messages;
                exist = messages.some(function (message) {
                    return params.id === message.id;
                });
                if (!exist) {
                    messages = messages.concat([params]);
                }
                else {
                    messages = messages.map(function (message) {
                        if (params.id === message.id) {
                            return params;
                        }
                        return message;
                    });
                }
                Log_1.default.info(messages.length, MessageCenter.counter);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.setState({ messages: messages }, function () {
                            resolve(params.id);
                        });
                    })];
            });
        });
    };
    MessageCenter.prototype.remove = function (id) {
        var messages = this.state.messages.filter(function (item) {
            return item.id !== id;
        });
        this.setState({ messages: messages });
    };
    MessageCenter.prototype.onHideItem = function (id) {
        var _this = this;
        var messageRef = this.refs["message" + id];
        if (messageRef) {
            messageRef.hide(function () {
                _this.remove(id);
            });
        }
    };
    MessageCenter.prototype.render = function () {
        var _this = this;
        var messages = this.state.messages;
        var topOffset = this.props.topOffset;
        var top = topOffset || 5;
        if (react_native_1.Platform.OS === 'ios') {
            //status bar
            top += 20;
        }
        return (React.createElement(View_1.default, { style: [styles.container, { top: top }] },
            React.createElement(View_1.default, { style: [styles.content, react_native_1.Platform.OS === 'web' && styles.contentWeb] }, messages.map(function (item, index) {
                return (React.createElement(MessageItem_1.default, { key: item.id, ref: "message" + item.id, onHide: _this.onHideItem.bind(_this, item.id), item: item }));
            }))));
    };
    return MessageCenter;
}(React.Component));
MessageCenter.counter = 0;
exports.default = MessageCenter;
var styles = react_native_1.StyleSheet.create({
    content: {
        zIndex: 100,
        minWidth: 200
    },
    contentWeb: {
        maxWidth: 500,
        alignSelf: 'center'
    },
    container: {
        overflow: 'hidden',
        zIndex: 100,
        elevation: 10,
        flex: 1,
        //position: Platform.OS === 'web' ? 'fixed' : 'absolute',
        position: 'absolute',
        right: 5,
        left: 5
    }
});
