/// <reference types="react" />
import * as React from 'react';
import { Animated, LayoutChangeEvent } from 'react-native';
import { AlertMessageProps } from './AlertMessage';
import EndCallback = Animated.EndCallback;
export interface Message extends AlertMessageProps {
    id?: string;
    title?: string;
    icon?: string;
    message?: string;
    isLoading?: boolean;
    autoDismiss?: number;
    type?: 'default' | 'primary' | 'danger' | 'warning' | 'info' | 'success';
}
export interface MessageItemProps {
    item: Message;
    onHide: () => void;
}
export interface State {
    top: Animated.Value;
    fade: Animated.Value;
    itemHeight: number;
}
export default class MessageItem extends React.PureComponent<MessageItemProps, State> {
    state: {
        top: Animated.Value;
        fade: Animated.Value;
        itemHeight: number;
    };
    private animation;
    private timeoutDismiss;
    onLayout(event: LayoutChangeEvent): void;
    show(): void;
    hide(cb: EndCallback): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    autoDismissSetup(): void;
    componentDidUpdate(prevProps: MessageItemProps, prevState: State): void;
    render(): JSX.Element;
}
