"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Screen_1 = require("../../modules/listener/Screen");
var View_1 = require("./View");
var Text_1 = require("./Text");
var Emitter_1 = require("../../modules/listener/Emitter");
var Button_1 = require("./Button");
var Translator_1 = require("../../modules/i18n/Translator");
var ScrollView_1 = require("./ScrollView");
var OptionItem_1 = require("./OptionItem");
var Theme_1 = require("../../modules/theme/Theme");
var Log_1 = require("../../modules/logger/Log");
var ModalActionItem = (function (_super) {
    __extends(ModalActionItem, _super);
    function ModalActionItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            fade: new react_native_1.Animated.Value(0),
            bottom: new react_native_1.Animated.Value(0),
            width: 0,
            height: 0,
            isVisible: true
        };
        return _this;
    }
    ModalActionItem.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var _a, width, height;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, Screen_1.default.updateDimensions()];
                    case 1:
                        _a = _b.sent(), width = _a.width, height = _a.height;
                        this.setState({ width: width, height: height }, function () {
                            _this.show();
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    ModalActionItem.prototype.onLayout = function (event) {
        var width = event.nativeEvent.layout.width;
        var item = this.props.item;
        var itemWidth = item.maxWidth || 400;
        if (width < itemWidth) {
            itemWidth = width;
        }
        Log_1.default.info('[ModalActionItem]', 'onLayout', width, itemWidth);
        this.setState({ width: itemWidth });
    };
    ModalActionItem.prototype.show = function () {
        var _this = this;
        var height = this.state.height;
        var bottom = new react_native_1.Animated.Value(height * -1);
        this.setState({ bottom: bottom }, function () {
            requestAnimationFrame(function () {
                _this.animation = react_native_1.Animated.parallel([
                    react_native_1.Animated.timing(_this.state.fade, {
                        toValue: 1,
                        delay: 200
                    }),
                    react_native_1.Animated.timing(_this.state.bottom, {
                        toValue: 0
                    })
                ]);
                _this.animation.start();
            });
        });
    };
    ModalActionItem.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
        if (this.animation) {
            this.animation.stop();
        }
    };
    ModalActionItem.prototype.hide = function (cb) {
        if (this.animation) {
            this.animation.stop();
        }
        var height = this.state.height;
        this.animation = react_native_1.Animated.parallel([
            react_native_1.Animated.timing(this.state.fade, {
                toValue: 0,
                duration: 300
            }),
            react_native_1.Animated.timing(this.state.bottom, {
                toValue: height * -1,
                duration: 200
            })
        ]);
        this.animation.start(cb);
    };
    ModalActionItem.prototype.onReturn = function () {
        if (this.props.item.onReturn) {
            this.props.item.onReturn();
        }
        this.props.onHide();
    };
    ModalActionItem.prototype.render = function () {
        var _a = this.state, fade = _a.fade, bottom = _a.bottom, width = _a.width;
        var _b = this.props, item = _b.item, onHide = _b.onHide;
        // let maxHeight = height - 50;
        return (React.createElement(View_1.default, { style: [styles.container, item.containerStyle] },
            React.createElement(react_native_1.Animated.View, { style: { zIndex: 10, bottom: bottom, flex: 1 } },
                React.createElement(react_native_1.TouchableWithoutFeedback, { onPress: onHide },
                    React.createElement(View_1.default, { style: [styles.container] },
                        React.createElement(View_1.default, { onLayout: this.onLayout.bind(this), ref: 'content', style: [styles.content, { width: width }] },
                            item.title &&
                                React.createElement(View_1.default, { style: [styles.header] },
                                    typeof item.title === 'object' && item.title,
                                    typeof item.title !== 'object' &&
                                        React.createElement(Text_1.default, { style: styles.title }, item.title.toUpperCase())),
                            item.body &&
                                React.createElement(View_1.default, { style: [styles.body] },
                                    typeof item.body === 'object' && item.body,
                                    typeof item.body !== 'object' &&
                                        React.createElement(Text_1.default, { style: styles.bodyText }, item.body)),
                            item.actions &&
                                React.createElement(ScrollView_1.default, { horizontal: false, style: styles.actionsContainer }, item.actions.map(function (option, index) {
                                    return React.createElement(OptionItem_1.default, __assign({}, option, { key: index }));
                                })),
                            React.createElement(View_1.default, { style: [styles.footer] }, item.onReturn &&
                                React.createElement(Button_1.default, { title: item.actionReturn || Translator_1._('Return'), style: styles.returnButton, onPress: this.onReturn.bind(this) })))))),
            React.createElement(react_native_1.Animated.View, { style: [styles.backdrop, { opacity: fade }] })));
    };
    return ModalActionItem;
}(React.PureComponent));
exports.default = ModalActionItem;
var styles = react_native_1.StyleSheet.create({
    returnButton: {
        flex: 1
    },
    actionsContainer: {
        marginBottom: 10
    },
    container: {
        zIndex: 10,
        position: 'absolute',
        justifyContent: 'flex-end',
        alignItems: 'center',
        right: 0,
        left: 0,
        top: 0,
        bottom: 0
    },
    backdrop: {
        backgroundColor: Theme_1.default.vars.modalActionItemBackgroundColor,
        zIndex: 9,
        //flex: 1,
        //position: Platform.OS === 'web' ? 'fixed' : 'absolute',
        position: 'absolute',
        right: 0,
        left: 0,
        top: 0,
        bottom: 0
    },
    footer: {
        flexDirection: 'row',
        padding: 10,
        borderTopWidth: 1,
        borderTopColor: Theme_1.default.vars.modalActionItemBorderColor
    },
    title: {
        fontSize: 12,
        textAlign: 'center',
        color: Theme_1.default.vars.modalActionItemTextColor,
        margin: 10,
        fontWeight: '500'
    },
    header: {},
    body: {
        padding: 5,
        paddingTop: 0,
        flexShrink: 1
        //flex:1,
    },
    bodyText: {
        padding: 5
    },
    content: {
        backgroundColor: Theme_1.default.vars.modalActionItemContentBackgroundColor,
        borderTopLeftRadius: 4,
        borderTopRightRadius: 4
    }
});
