"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
//import Icon, {IconType} from './Icon';
var Touchable_1 = require("./Touchable");
var View_1 = require("./View");
var Image_1 = require("./Image");
var Text_1 = require("./Text");
var Theme_1 = require("../../modules/theme/Theme");
var OptionItem = (function (_super) {
    __extends(OptionItem, _super);
    function OptionItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OptionItem.prototype.render = function () {
        var _a = this.props, icon = _a.icon, image = _a.image, title = _a.title, onPress = _a.onPress;
        return (React.createElement(Touchable_1.default, { style: styles.button, onPress: onPress },
            React.createElement(View_1.default, { style: [styles.container, image && styles.containerAlter] },
                image && React.createElement(Image_1.default, { style: styles.image, source: { uri: image } }),
                React.createElement(Text_1.default, { style: styles.title }, title))));
    };
    return OptionItem;
}(React.Component));
exports.default = OptionItem;
var styles = react_native_1.StyleSheet.create({
    containerAlter: {
        paddingTop: 2,
        paddingBottom: 2,
        borderTopWidth: 0.5,
        borderTopColor: Theme_1.default.vars.optionItemBorderColor
    },
    container: {
        flexDirection: 'row',
        alignItems: 'center',
        paddingTop: 10,
        paddingBottom: 10
    },
    icon: {
        marginLeft: 10,
        color: Theme_1.default.vars.optionItemIconColor
    },
    image: {
        marginLeft: 10,
        width: 40,
        height: 40
    },
    title: {
        marginLeft: 10,
        fontSize: 14,
        color: Theme_1.default.vars.optionItemTextColor,
        fontWeight: '400'
    },
    button: {
        flex: 1
    }
});
