"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Log_1 = require("../logger/Log");
var react_native_google_analytics_1 = require("react-native-google-analytics");
var Network_1 = require("../listener/Network");
var DeviceInfo = require('react-native-device-info');
var Analytics = (function () {
    function Analytics() {
    }
    Analytics.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
        if (!this.ga) {
            var userAgent = DeviceInfo.getUserAgent().replace(/[^\w\s./;()]/gi, '');
            this.ga = new react_native_google_analytics_1.Analytics(this.settings.analyticsId, DeviceInfo.getUniqueID(), 1, userAgent);
        }
        Log_1.default.info('[GA]', 'init');
    };
    Analytics.screenView = function (path) {
        if (!Network_1.default.isConnected()) {
            return;
        }
        var screenView = new react_native_google_analytics_1.Hits.ScreenView(this.settings.appName, path, DeviceInfo.getReadableVersion(), DeviceInfo.getBundleId());
        this.ga.send(screenView);
    };
    Analytics.event = function (params) {
        if (!Network_1.default.isConnected()) {
            return;
        }
        var experiment = new react_native_google_analytics_1.Experiment(this.settings.appName, 'Exp');
        var screenView = new react_native_google_analytics_1.Hits.Event(params.eventCategory, params.eventAction, params.eventLabel, params.eventValue || 0, experiment);
        this.ga.send(screenView);
    };
    return Analytics;
}());
Analytics.settings = { analyticsId: '', appName: '' };
exports.default = Analytics;
