"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @flow
 */
var SEO_1 = require("../seo/SEO");
var Log_1 = require("../logger/Log");
var AnalyticsWeb = (function () {
    function AnalyticsWeb() {
    }
    AnalyticsWeb.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
        Log_1.default.info('[GA]', 'init', this.settings);
        if (!SEO_1.default.isSEORequest() && !this.isLoaded) {
            (function (i, s, o, g, r, ab, mb) {
                i['GoogleAnalyticsObject'] = r;
                (i[r] =
                    i[r] ||
                        function () {
                            (i[r].q = i[r].q || []).push(arguments);
                        }), (i[r].l = new Date().getTime());
                var a = s.createElement(o);
                var m = s.getElementsByTagName(o)[0];
                a.async = 1;
                a.src = g;
                m.parentNode.insertBefore(a, m);
            })(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');
            ga('create', this.settings.analyticsId, 'auto');
            this.isLoaded = true;
        }
    };
    AnalyticsWeb.screenView = function (path) {
        window.prerenderReady = true;
        Log_1.default.log('prerenderReady');
        setTimeout(function () {
            if (SEO_1.default.isSEORequest()) {
                window.callPhantom();
                Log_1.default.log('callPhantom');
            }
        }, 10);
        if (!path) {
            path = window.location.pathname;
        }
        try {
            if (typeof ga === 'function') {
                ga('send', 'pageview', path);
            }
        }
        catch (e) {
            Log_1.default.error('[GA]', e);
        }
    };
    AnalyticsWeb.event = function (params) {
        if (typeof ga === 'function') {
            ga('send', 'event', __assign({}, params));
        }
    };
    return AnalyticsWeb;
}());
AnalyticsWeb.settings = { analyticsId: '', appName: '' };
AnalyticsWeb.isLoaded = false;
exports.default = AnalyticsWeb;
