export interface UserSettings {
    translations: Translations;
    defaultLocale?: string;
}
export interface Settings {
    translations: Translations;
    defaultLocale: string;
}
export declare type TranslationText = string | number;
export interface Locale {
    [key: string]: string;
}
export interface Params {
    [key: string]: TranslationText;
}
export interface Translations {
    [key: string]: Locale;
}
export declare function _(key: string, params?: Params): string;
export default class Translator {
    static settings: Settings;
    static locale: string;
    static init(settings: UserSettings): Promise<void>;
    static setLocale(locale: string): void;
    static getLocale(): string;
    static translate(text: string, params?: Params): string;
    static getUserLocale(): Promise<string>;
    static getSystemLocale(): string;
}
