"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_1 = require("react-native");
var Log_1 = require("../logger/Log");
var Translator_1 = require("../i18n/Translator");
var Emitter_1 = require("./Emitter");
var Geolocation = (function () {
    function Geolocation() {
    }
    Geolocation.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
        this.checkWatcher(true);
    };
    Geolocation.getPosition = function () {
        Log_1.default.log('[GEOLOCATION]', 'getPosition');
        var lastPosition = this.lastPosition || { coords: {} };
        var initialPosition = this.initialPosition || { coords: {} };
        return lastPosition.coords || initialPosition.coords;
    };
    Geolocation.checkWatcher = function (forced) {
        if (forced === void 0) { forced = true; }
        return __awaiter(this, void 0, void 0, function () {
            var allowed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.log('[GEOLOCATION]', 'checkWatcher', forced);
                        return [4 /*yield*/, this.isAllowedToCheck()];
                    case 1:
                        allowed = _a.sent();
                        if (!(!allowed && forced)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.requestPermission()];
                    case 2:
                        allowed = _a.sent();
                        _a.label = 3;
                    case 3:
                        if (allowed) {
                            this.initWatcher();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Geolocation.destroy = function () {
        try {
            navigator.geolocation.clearWatch(this.watchID);
        }
        catch (e) {
            Log_1.default.warn('[GEOLOCATION]', '[ERROR]', e);
        }
    };
    Geolocation.updateLocation = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                Log_1.default.log('[GEOLOCATION]', 'updateLocation');
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        navigator.geolocation.getCurrentPosition(function (initialPosition) {
                            _this.initialPosition = initialPosition;
                            var coords = initialPosition.coords;
                            Emitter_1.default.emit('onLocationChange', coords);
                            Log_1.default.log('[GEOLOCATION]', 'navigator', 'getCurrentPosition', coords);
                            resolve(coords);
                        }, function (error) {
                            reject(error);
                            Log_1.default.warn('[GEOLOCATION]', '[ERROR]', error);
                        }, {
                            enableHighAccuracy: true,
                            timeout: 1000 * 30,
                            maximumAge: 0
                        });
                    })];
            });
        });
    };
    Geolocation.initWatcher = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.log('[GEOLOCATION]', 'initWatcher');
                        if (this.watchID) {
                            navigator.geolocation.clearWatch(this.watchID);
                        }
                        return [4 /*yield*/, this.updateLocation()];
                    case 1:
                        _a.sent();
                        try {
                            this.watchID = navigator.geolocation.watchPosition(function (lastPosition) {
                                _this.lastPosition = lastPosition;
                                var coords = lastPosition.coords;
                                Emitter_1.default.emit('onLocationChange', coords);
                                Log_1.default.log('[GEOLOCATION]', 'navigator', 'watchPosition', coords);
                            }, function (error) {
                                Log_1.default.warn('[GEOLOCATION]', '[ERROR]', error);
                            }, {
                                enableHighAccuracy: true,
                                maximumAge: 0
                            });
                        }
                        catch (e) {
                            Log_1.default.warn('[GEOLOCATION]', '[ERROR]', e);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Geolocation.requestPermission = function () {
        return __awaiter(this, void 0, void 0, function () {
            var isAllowed, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.log('[GEOLOCATION]', 'requestPermission');
                        isAllowed = true;
                        if (!(react_native_1.Platform.OS === 'android')) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, react_native_1.PermissionsAndroid.requestPermission(react_native_1.PermissionsAndroid.PERMISSIONS.ACCESS_FINE_LOCATION, {
                                title: this.settings.messageTitle,
                                message: this.settings.messageDescription
                            })];
                    case 2:
                        isAllowed = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        Log_1.default.warn('[GEOLOCATION]', '[ERROR]', err_1);
                        isAllowed = false;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, isAllowed];
                }
            });
        });
    };
    Geolocation.isAllowedToCheck = function () {
        return __awaiter(this, void 0, void 0, function () {
            var isAllowed, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.log('[GEOLOCATION]', 'isAllowedToCheck');
                        isAllowed = true;
                        if (!(react_native_1.Platform.OS === 'android')) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, react_native_1.PermissionsAndroid.check(react_native_1.PermissionsAndroid.PERMISSIONS.ACCESS_FINE_LOCATION)];
                    case 2:
                        isAllowed = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        Log_1.default.warn('[GEOLOCATION]', '[ERROR]', e_1);
                        isAllowed = false;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, isAllowed];
                }
            });
        });
    };
    return Geolocation;
}());
Geolocation.settings = {
    messageTitle: Translator_1._('Permission required'),
    messageDescription: Translator_1._('must allow to continue')
};
Geolocation.watchID = 0;
exports.default = Geolocation;
