"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Emitter_1 = require("./Emitter");
var react_native_1 = require("react-native");
var Log_1 = require("../logger/Log");
var Network = (function () {
    function Network() {
    }
    Network.init = function () {
        this.isReady = true;
        this.changeListener = this.stateChange.bind(this);
        react_native_1.NetInfo.addEventListener('change', this.changeListener);
        this.checkAppStateBinded = this.checkAppState.bind(this);
        react_native_1.AppState.addEventListener('change', this.checkAppStateBinded);
    };
    Network.destroy = function () {
        this.isReady = false;
        react_native_1.NetInfo.removeEventListener('change', this.changeListener);
        react_native_1.AppState.removeEventListener('change', this.checkAppStateBinded);
    };
    Network.isConnected = function () {
        return this.last !== 'OFF';
    };
    Network.getType = function () {
        return this.last;
    };
    Network.updateNetworkType = function () {
        return __awaiter(this, void 0, void 0, function () {
            var info;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.log('[NETWORK]', 'updateNetworkType');
                        return [4 /*yield*/, react_native_1.NetInfo.fetch()];
                    case 1:
                        info = _a.sent();
                        return [4 /*yield*/, this.stateChange(info)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Network.checkAppState = function (newState) {
        if (newState === 'active') {
            this.updateNetworkType();
        }
    };
    Network.parse = function (reach) {
        reach = reach.toUpperCase();
        var type = 'UNKNOWN';
        if (react_native_1.Platform.OS === 'ios') {
            switch (reach) {
                case 'NONE':
                    type = 'OFF';
                    break;
                case 'WIFI':
                    type = 'WIFI';
                    break;
                case 'CELL':
                    type = 'MOBILE';
                    break;
                case 'UNKNOWN':
                default:
                    type = 'UNKNOWN';
                    break;
            }
        }
        else if (react_native_1.Platform.OS === 'android') {
            switch (reach) {
                case 'NONE':
                    type = 'OFF';
                    break;
                case 'DUMMY':
                case 'ETHERNET':
                case 'VPN':
                case 'WIFI':
                case 'WIMAX':
                    type = 'WIFI';
                    break;
                case 'MOBILE':
                case 'MOBILE_DUN':
                case 'MOBILE_HIPRI':
                case 'MOBILE_SUPL':
                    type = 'MOBILE';
                    break;
                case 'BLUETOOTH':
                case 'UNKNOWN':
                default:
                    type = 'UNKNOWN';
                    break;
            }
        }
        return type;
    };
    Network.stateChange = function (reach) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                Log_1.default.log('[NETWORK]', 'onNetworkStateChange', reach);
                this.last = Network.parse(reach);
                Emitter_1.default.emit('onNetworkStateChange', this.last);
                return [2 /*return*/, this.last];
            });
        });
    };
    return Network;
}());
Network.isReady = true;
Network.last = 'UNKNOWN';
exports.default = Network;
