"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_1 = require("react-native");
var Emitter_1 = require("./Emitter");
var Log_1 = require("../logger/Log");
var OrientationListener = require('react-native-orientation');
var Screen = (function () {
    function Screen() {
    }
    Screen.init = function () {
        this.updateDimensionsBinded = this.didUpdateDimensions.bind(this);
        this.checkAppStateBinded = this.checkAppState.bind(this);
        this.updateOrientation();
        this.updateDimensions();
        react_native_1.DeviceEventEmitter.addListener('didUpdateDimensions', this.updateDimensionsBinded);
        react_native_1.AppState.addEventListener('change', this.checkAppStateBinded);
    };
    Screen.getDimensions = function () {
        return this.dimensions;
    };
    Screen.getOrientation = function () {
        return this.last;
    };
    Screen.destroy = function () {
        react_native_1.AppState.removeEventListener('change', this.checkAppStateBinded);
        react_native_1.DeviceEventEmitter.addListener('didUpdateDimensions', this.updateDimensionsBinded);
    };
    Screen.updateOrientation = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        OrientationListener.getOrientation(function (err, orientation) {
                            if (!_this.first) {
                                _this.first = orientation.replace('UPSIDEDOWN', '');
                            }
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve(_this.orientationChange(orientation));
                            }
                        });
                    })];
            });
        });
    };
    Screen.updateDimensions = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dimensions;
            return __generator(this, function (_a) {
                dimensions = this.getScreenDimensions();
                this.didUpdateDimensions(dimensions);
                return [2 /*return*/, dimensions];
            });
        });
    };
    Screen.didUpdateDimensions = function (update) {
        Log_1.default.log('[SCREEN]', 'didUpdateDimensions', update);
        var dimension = this.getScreenDimensions();
        //FIXME
        //if (this.dimensions !== dimension) {
        this.dimensions = dimension;
        Emitter_1.default.emit('onDimensionsChange', this.dimensions);
        this.updateOrientation();
        //}
    };
    Screen.checkAppState = function (newState) {
        if (newState === 'active') {
            this.updateOrientation();
        }
    };
    Screen.orientationChange = function (orientation) {
        orientation = orientation.replace('UPSIDEDOWN', '');
        if (!orientation || orientation === 'null') {
            return this.last;
        }
        this.last = orientation;
        Emitter_1.default.emit('onOrientationChange', orientation);
        Log_1.default.log('[SCREEN]', 'onOrientationChange', orientation);
        return this.last;
    };
    Screen.getScreenDimensions = function () {
        return react_native_1.Dimensions.get('window');
    };
    return Screen;
}());
Screen.dimensions = {
    scale: 1,
    fontScale: 1,
    width: 1000,
    height: 1000
};
Screen.last = 'PORTRAIT';
exports.default = Screen;
