export interface UserSettings {
    headerName?: string;
    authPath?: string;
}
export interface Settings {
    headerName: string;
    authPath: string;
}
export interface User {
    [key: string]: string | boolean | number;
}
export default class Auth {
    static settings: Settings;
    private static user;
    private static accessToken;
    static init(settings?: UserSettings): Promise<void>;
    static checkLogin(): Promise<void>;
    static login(tmpAccessToken: string): Promise<boolean>;
    static isLoggedIn(): boolean;
    static getAccessToken(): string;
    static getUser(): User;
    static setAccessToken(value: string): Promise<boolean>;
    static logout(): Promise<boolean>;
}
