"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var SingleStorage_1 = require("../storage/SingleStorage");
var Request_1 = require("../network/Request");
var Emitter_1 = require("../listener/Emitter");
var Log_1 = require("../logger/Log");
var Auth = (function () {
    function Auth() {
    }
    Auth.init = function (settings) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (settings) {
                            this.settings = Object.assign({}, this.settings, settings);
                        }
                        Log_1.default.info('[AUTH]', 'init');
                        return [4 /*yield*/, this.checkLogin()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Auth.checkLogin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isLoggedIn()) {
                            return [2 /*return*/];
                        }
                        Log_1.default.info('[AUTH]', 'checkLogin');
                        return [4 /*yield*/, SingleStorage_1.default.get('accessToken')];
                    case 1:
                        data = _a.sent();
                        if (!data) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.login(data)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        Log_1.default.info('[AUTH]', 'onNoLogin');
                        Emitter_1.default.emit('onNoLogin', true);
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Auth.login = function (tmpAccessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var isOk, response, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.info('[AUTH]', 'login', tmpAccessToken);
                        isOk = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        this.accessToken = tmpAccessToken;
                        return [4 /*yield*/, Request_1.default.get(this.settings.authPath, {}, 'auth_login', { secure: true })];
                    case 2:
                        response = _a.sent();
                        this.user = response.body;
                        return [4 /*yield*/, this.setAccessToken(tmpAccessToken)];
                    case 3:
                        _a.sent();
                        Log_1.default.info('[AUTH]', 'onSuccessLogin');
                        Emitter_1.default.emit('onSuccessLogin', this.user);
                        isOk = true;
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        Log_1.default.warn('[AUTH]', 'login', e_1);
                        this.accessToken = '';
                        Emitter_1.default.emit('onNoLogin', true);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, isOk];
                }
            });
        });
    };
    Auth.isLoggedIn = function () {
        return !!this.accessToken;
    };
    Auth.getAccessToken = function () {
        return this.accessToken;
    };
    Auth.getUser = function () {
        return this.user;
    };
    Auth.setAccessToken = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.accessToken = value;
                return [2 /*return*/, SingleStorage_1.default.set('accessToken', value)];
            });
        });
    };
    Auth.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ok, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        Log_1.default.info('[AUTH]', 'logout');
                        this.accessToken = '';
                        this.user = {};
                        Emitter_1.default.emit('onNoLogin', true);
                        ok = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, SingleStorage_1.default.remove('accessToken')];
                    case 2:
                        ok = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        Log_1.default.error('[AUTH]', 'logout', e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, ok];
                }
            });
        });
    };
    return Auth;
}());
Auth.settings = {
    headerName: 'X-APIKey',
    authPath: 'auth/me'
};
Auth.user = {};
Auth.accessToken = '';
exports.default = Auth;
