"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Realm = require("realm");
var CacheSchema = {
    name: 'Cache',
    primaryKey: 'key',
    properties: {
        key: 'string',
        value: 'string'
    }
};
var CacheStorage = (function () {
    function CacheStorage() {
    }
    CacheStorage.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
        if (this.realm) {
            return;
        }
        this.realm = new Realm({
            schema: [CacheSchema],
            path: this.settings.path,
            schemaVersion: this.settings.schemaVersion
        });
    };
    CacheStorage.set = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.realm.write(function () {
                            var cache = _this.realm.create('Cache', {
                                key: _this.hashCode(key),
                                value: JSON.stringify(value)
                            }, true);
                            resolve(true);
                        });
                    })];
            });
        });
    };
    CacheStorage.get = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var keyEncoded = _this.hashCode(key);
                        var result = _this.realm.objectForPrimaryKey('Cache', keyEncoded);
                        if (result && result.value) {
                            resolve(JSON.parse(result.value));
                        }
                        else {
                            reject({ code: 404, error: true });
                        }
                    })];
            });
        });
    };
    CacheStorage.remove = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var keyEncoded = _this.hashCode(key);
                        var results = _this.realm
                            .objects('Cache')
                            .filtered("key = '" + keyEncoded + "'");
                        _this.realm.write(function () {
                            if (results) {
                                _this.realm.delete(results);
                                resolve(true);
                            }
                            else {
                                reject(false);
                            }
                        });
                    })];
            });
        });
    };
    CacheStorage.hashCode = function (text) {
        var hash = 0, i, chr, len;
        if (text.length === 0) {
            return hash.toString();
        }
        for (i = 0, len = text.length; i < len; i++) {
            chr = text.charCodeAt(i);
            hash = (hash << 5) - hash + chr;
            hash |= 0; // Convert to 32bit integer
        }
        return 'K' + hash;
    };
    return CacheStorage;
}());
CacheStorage.settings = { path: 'cache.realm', schemaVersion: 1 };
exports.default = CacheStorage;
