"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var PouchDB = require('pouchdb-browser');
var Log_1 = require("../logger/Log");
var CacheStorageWeb = (function () {
    function CacheStorageWeb() {
    }
    CacheStorageWeb.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
        if (this.db) {
            return;
        }
        this.db = new PouchDB(this.settings.path);
    };
    CacheStorageWeb.set = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var keyEncoded, doc, err_1, result, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        keyEncoded = this.hashCode(key);
                        doc = { _id: '', value: '' };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.db.get(keyEncoded)];
                    case 2:
                        doc = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        Log_1.default.warn('[CACHE]', err_1);
                        return [3 /*break*/, 4];
                    case 4:
                        doc.value = value;
                        if (!doc._id) {
                            doc._id = keyEncoded;
                        }
                        result = false;
                        _a.label = 5;
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, this.db.put(doc)];
                    case 6:
                        _a.sent();
                        result = true;
                        return [3 /*break*/, 8];
                    case 7:
                        e_1 = _a.sent();
                        Log_1.default.warn('[CACHE]', e_1);
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/, result];
                }
            });
        });
    };
    CacheStorageWeb.get = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var data, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = { _id: '', value: '' };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.db.get(this.hashCode(key))];
                    case 2:
                        data = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        Log_1.default.warn('[CACHE]', e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, data.value];
                }
            });
        });
    };
    CacheStorageWeb.remove = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var data, result, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = {
                            _id: this.hashCode(key)
                        };
                        result = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.db.remove(data)];
                    case 2:
                        _a.sent();
                        result = true;
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        Log_1.default.warn('[CACHE]', e_3);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, result];
                }
            });
        });
    };
    CacheStorageWeb.hashCode = function (text) {
        var hash = 0, i, chr, len;
        if (text.length === 0) {
            return hash.toString();
        }
        for (i = 0, len = text.length; i < len; i++) {
            chr = text.charCodeAt(i);
            hash = (hash << 5) - hash + chr;
            hash |= 0; // Convert to 32bit integer
        }
        return 'K' + hash;
    };
    return CacheStorageWeb;
}());
CacheStorageWeb.settings = { path: 'cache.realm', schemaVersion: 1 };
exports.default = CacheStorageWeb;
