export interface UserSettings {
    defaults?: Preferences;
}
export interface Settings {
    defaults: Preferences;
}
export declare type PreferenceValue = boolean | string;
export interface Preferences {
    [key: string]: PreferenceValue;
}
export default class PreferencesStorage {
    static settings: Settings;
    static cache: any;
    static init(settings?: UserSettings): void;
    static getDefault(key: string): PreferenceValue;
    static set(key: string, value: PreferenceValue): Promise<boolean>;
    static get(key: string): Promise<PreferenceValue>;
    static remove(key: string): Promise<boolean>;
}
