"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var SingleStorage_1 = require("./SingleStorage");
var Log_1 = require("../logger/Log");
var PreferencesStorage = (function () {
    function PreferencesStorage() {
    }
    PreferencesStorage.init = function (settings) {
        if (settings) {
            this.settings = Object.assign({}, this.settings, settings);
        }
    };
    PreferencesStorage.getDefault = function (key) {
        return this.settings.defaults[key];
    };
    PreferencesStorage.set = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var savedValue;
            return __generator(this, function (_a) {
                if (typeof value === 'undefined') {
                    return [2 /*return*/, false];
                }
                this.cache[key] = value;
                savedValue = '';
                Log_1.default.info('[PREF]', '[FAST]', 'set', key, this.cache[key]);
                if (typeof value === 'boolean') {
                    savedValue = value ? 'ON' : 'OFF';
                }
                else {
                    savedValue = value;
                }
                return [2 /*return*/, SingleStorage_1.default.set(key, savedValue)];
            });
        });
    };
    PreferencesStorage.get = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var defaultValue, value, data, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof this.cache[key] !== 'undefined') {
                            Log_1.default.info('[PREF]', '[FAST]', 'get', key, this.cache[key]);
                            return [2 /*return*/, this.cache[key]];
                        }
                        defaultValue = this.getDefault(key);
                        value = '';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, SingleStorage_1.default.get(key)];
                    case 2:
                        data = _a.sent();
                        if ((typeof data === 'undefined' || data === null) &&
                            typeof defaultValue !== 'undefined') {
                            value = defaultValue;
                        }
                        else if (data === 'ON') {
                            value = true;
                        }
                        else if (data === 'OFF') {
                            value = false;
                        }
                        else {
                            value = data;
                        }
                        this.cache[key] = value;
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        if (typeof defaultValue !== 'undefined') {
                            value = defaultValue;
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, value];
                }
            });
        });
    };
    PreferencesStorage.remove = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, SingleStorage_1.default.remove(key)];
            });
        });
    };
    return PreferencesStorage;
}());
PreferencesStorage.settings = {
    defaults: {
        locale: 'auto',
        sampleBool: true
    }
};
PreferencesStorage.cache = {};
exports.default = PreferencesStorage;
