import { ThemeVars } from './ThemeBuilder';
export interface UserSettings {
    themes: Themes;
    defaultTheme?: string;
}
export interface Settings {
    themes: Themes;
    defaultTheme: string;
}
export interface Themes {
    [key: string]: ThemeVars;
}
export default class Theme {
    static settings: Settings;
    static theme: string;
    static vars: ThemeVars;
    static init(settings: UserSettings): Promise<void>;
    static setTheme(theme: string): void;
    static getTheme(): string;
    static getUserTheme(): Promise<string>;
    static getDefaultTheme(): string;
}
