"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var PreferencesStorage_1 = require("../storage/PreferencesStorage");
var Emitter_1 = require("../listener/Emitter");
var Log_1 = require("../logger/Log");
var Default_1 = require("./themes/Default");
var Darker_1 = require("./themes/Darker");
var Demo_1 = require("./themes/Demo");
var Theme = (function () {
    function Theme() {
    }
    Theme.init = function (settings) {
        return __awaiter(this, void 0, void 0, function () {
            var theme, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (settings) {
                            this.settings = Object.assign({}, this.settings, settings);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getTheme()];
                    case 2:
                        theme = _a.sent();
                        this.setTheme(theme);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        Log_1.default.debug('[THEME]', e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Theme.setTheme = function (theme) {
        this.theme = theme;
        this.vars = __assign({}, this.vars, this.settings.themes[this.theme]);
        Emitter_1.default.emit('onThemeChange', this.theme);
    };
    Theme.getTheme = function () {
        return this.theme;
    };
    Theme.getUserTheme = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, theme, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, PreferencesStorage_1.default.get('theme')];
                    case 1:
                        data = _a.sent();
                        theme = data.toString();
                        return [2 /*return*/, theme ? theme : this.getDefaultTheme()];
                    case 2:
                        e_2 = _a.sent();
                        return [2 /*return*/, this.getDefaultTheme()];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Theme.getDefaultTheme = function () {
        return this.settings.defaultTheme;
    };
    return Theme;
}());
Theme.settings = {
    themes: { Default: Default_1.default, Demo: Demo_1.default, Darker: Darker_1.default },
    defaultTheme: 'Demo'
};
Theme.theme = Theme.getDefaultTheme();
Theme.vars = Demo_1.default;
exports.default = Theme;
