export default class ThemeBuilder {
    static allowShadow(): boolean;
    static build(defaults: ThemeDefaultVars): ThemeVars;
}
export interface ThemeDefaultVars {
    darkMode: boolean;
    defaultColor: string;
    primaryColor: string;
    dangerColor: string;
    warningColor: string;
    infoColor: string;
    successColor: string;
    textShadowColor: string;
    shadowColor: string;
    textColor: string;
    textSecondaryColor: string;
    textActiveColor: string;
    textActiveSecondaryColor: string;
    backgroundColor: string;
    backgroundSecondaryColor: string;
    backgroundDarkenColor: string;
    borderColor: string;
    borderSecondaryColor: string;
}
export interface ThemeVars {
    defaults: ThemeDefaultVars;
    darkMode: boolean;
    loadingColor: string;
    labelDefaultIconColor: string;
    labelPrimaryIconColor: string;
    labelDangerIconColor: string;
    labelWarningIconColor: string;
    labelInfoIconColor: string;
    labelSuccessIconColor: string;
    labelDefaultTextColor: string;
    labelPrimaryTextColor: string;
    labelDangerTextColor: string;
    labelWarningTextColor: string;
    labelInfoTextColor: string;
    labelSuccessTextColor: string;
    labelDefaultBackgroundColor: string;
    labelPrimaryBackgroundColor: string;
    labelDangerBackgroundColor: string;
    labelWarningBackgroundColor: string;
    labelInfoBackgroundColor: string;
    labelSuccessBackgroundColor: string;
    buttonDefaultIconColor: string;
    buttonPrimaryIconColor: string;
    buttonDangerIconColor: string;
    buttonWarningIconColor: string;
    buttonInfoIconColor: string;
    buttonSuccessIconColor: string;
    buttonDefaultTextColor: string;
    buttonPrimaryTextColor: string;
    buttonDangerTextColor: string;
    buttonWarningTextColor: string;
    buttonInfoTextColor: string;
    buttonSuccessTextColor: string;
    buttonDefaultBackgroundColor: string;
    buttonPrimaryBackgroundColor: string;
    buttonDangerBackgroundColor: string;
    buttonWarningBackgroundColor: string;
    buttonInfoBackgroundColor: string;
    buttonSuccessBackgroundColor: string;
    buttonDefaultShadowColor: string;
    buttonPrimaryShadowColor: string;
    buttonDangerShadowColor: string;
    buttonWarningShadowColor: string;
    buttonInfoShadowColor: string;
    buttonSuccessShadowColor: string;
    linkTextColor: string;
    linkIconColor: string;
    inputPlaceholderColor: string;
    inputLabelColor: string;
    inputBorderColor: string;
    inputBackgroundColor: string;
    inputTextColor: string;
    inputErrorPlaceholderColor: string;
    inputErrorLabelColor: string;
    inputErrorBorderColor: string;
    inputErrorBackgroundColor: string;
    inputErrorTextColor: string;
    alertMessageDefaultIconColor: string;
    alertMessagePrimaryIconColor: string;
    alertMessageDangerIconColor: string;
    alertMessageWarningIconColor: string;
    alertMessageInfoIconColor: string;
    alertMessageSuccessIconColor: string;
    alertMessageDefaultTitleColor: string;
    alertMessagePrimaryTitleColor: string;
    alertMessageDangerTitleColor: string;
    alertMessageWarningTitleColor: string;
    alertMessageInfoTitleColor: string;
    alertMessageSuccessTitleColor: string;
    alertMessageDefaultTextColor: string;
    alertMessagePrimaryTextColor: string;
    alertMessageDangerTextColor: string;
    alertMessageWarningTextColor: string;
    alertMessageInfoTextColor: string;
    alertMessageSuccessTextColor: string;
    alertMessageDefaultBackgroundColor: string;
    alertMessagePrimaryBackgroundColor: string;
    alertMessageDangerBackgroundColor: string;
    alertMessageWarningBackgroundColor: string;
    alertMessageInfoBackgroundColor: string;
    alertMessageSuccessBackgroundColor: string;
    blurImageBackgroundColor: string;
    blurImageOverlayBackgroundColor: string;
    drawerBackgroundColor: string;
    drawerOverlayBackgroundColor: string;
    drawerContentBackgroundColor: string;
    drawerShadowColor: string;
    drawerFooterTextColor: string;
    drawerFooterIconColor: string;
    drawerFooterBorderColor: string;
    drawerHeaderTextColor: string;
    drawerHeaderBackgroundColor: string;
    drawerItemHeaderTextColor: string;
    drawerItemHeaderBorderColor: string;
    drawerItemTextColor: string;
    drawerItemIconColor: string;
    drawerItemActiveTextColor: string;
    drawerItemActiveIconColor: string;
    drawerItemActiveBackgroundColor: string;
    headerIconColor: string;
    headerTextColor: string;
    headerBackgroundColor: string;
    headerShadowColor: string;
    headerActionIconColor: string;
    modalActionItemBackgroundColor: string;
    modalActionItemBorderColor: string;
    modalActionItemTextColor: string;
    modalActionItemContentBackgroundColor: string;
    modalItemBackgroundColor: string;
    modalItemBorderColor: string;
    modalItemTextColor: string;
    modalItemContentBackgroundColor: string;
    optionItemBorderColor: string;
    optionItemIconColor: string;
    optionItemTextColor: string;
    progressBarActiveColor: string;
    refreshControlTintColor: string;
    refreshControlColor: string;
    sliderActiveColor: string;
    sliderThumbColor: string;
    statusBarViewBackgroundIOSColor: string;
    statusBarViewBackgroundAndroidColor: string;
    switchTintColor: string;
    switchOnTintColor: string;
    switchThumbTintColor: string;
    panelShadowColor: string;
    panelIconColor: string;
    panelTextColor: string;
    panelBackgroundColor: string;
    panelBorderColor: string;
    textColor: string;
    titleColor: string;
}
