"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TinyColor = require('tinycolor2');
var react_native_1 = require("react-native");
var ThemeBuilder = (function () {
    function ThemeBuilder() {
    }
    ThemeBuilder.allowShadow = function () {
        return !(react_native_1.Platform.OS === 'android' && react_native_1.Platform.Version < 21);
    };
    ThemeBuilder.build = function (defaults) {
        var allowShadow = this.allowShadow();
        return {
            defaults: defaults,
            darkMode: defaults.darkMode,
            loadingColor: defaults.textColor,
            labelDefaultIconColor: defaults.textSecondaryColor,
            labelPrimaryIconColor: defaults.textActiveSecondaryColor,
            labelDangerIconColor: defaults.textActiveSecondaryColor,
            labelWarningIconColor: defaults.textActiveSecondaryColor,
            labelInfoIconColor: defaults.textActiveSecondaryColor,
            labelSuccessIconColor: defaults.textActiveSecondaryColor,
            labelDefaultTextColor: defaults.textColor,
            labelPrimaryTextColor: defaults.textActiveColor,
            labelDangerTextColor: defaults.textActiveColor,
            labelWarningTextColor: defaults.textActiveColor,
            labelInfoTextColor: defaults.textActiveColor,
            labelSuccessTextColor: defaults.textActiveColor,
            labelDefaultBackgroundColor: defaults.defaultColor,
            labelPrimaryBackgroundColor: defaults.primaryColor,
            labelDangerBackgroundColor: defaults.dangerColor,
            labelWarningBackgroundColor: defaults.warningColor,
            labelInfoBackgroundColor: defaults.infoColor,
            labelSuccessBackgroundColor: defaults.successColor,
            buttonDefaultIconColor: defaults.textSecondaryColor,
            buttonPrimaryIconColor: defaults.textActiveSecondaryColor,
            buttonDangerIconColor: defaults.textActiveSecondaryColor,
            buttonWarningIconColor: defaults.textActiveSecondaryColor,
            buttonInfoIconColor: defaults.textActiveSecondaryColor,
            buttonSuccessIconColor: defaults.textActiveSecondaryColor,
            buttonDefaultTextColor: defaults.textColor,
            buttonPrimaryTextColor: defaults.textActiveColor,
            buttonDangerTextColor: defaults.textActiveColor,
            buttonWarningTextColor: defaults.textActiveColor,
            buttonInfoTextColor: defaults.textActiveColor,
            buttonSuccessTextColor: defaults.textActiveColor,
            buttonDefaultBackgroundColor: defaults.defaultColor,
            buttonPrimaryBackgroundColor: defaults.primaryColor,
            buttonDangerBackgroundColor: defaults.dangerColor,
            buttonWarningBackgroundColor: defaults.warningColor,
            buttonInfoBackgroundColor: defaults.infoColor,
            buttonSuccessBackgroundColor: defaults.successColor,
            buttonDefaultShadowColor: TinyColor(defaults.defaultColor)
                .darken(4)
                .toHexString(),
            buttonPrimaryShadowColor: TinyColor(defaults.primaryColor)
                .darken(4)
                .toHexString(),
            buttonDangerShadowColor: TinyColor(defaults.dangerColor)
                .darken(4)
                .toHexString(),
            buttonWarningShadowColor: TinyColor(defaults.warningColor)
                .darken(4)
                .toHexString(),
            buttonInfoShadowColor: TinyColor(defaults.infoColor)
                .darken(4)
                .toHexString(),
            buttonSuccessShadowColor: TinyColor(defaults.successColor)
                .darken(4)
                .toHexString(),
            linkTextColor: defaults.primaryColor,
            linkIconColor: defaults.primaryColor,
            inputPlaceholderColor: defaults.textSecondaryColor,
            inputLabelColor: defaults.textSecondaryColor,
            inputBorderColor: defaults.borderColor,
            inputBackgroundColor: TinyColor(defaults.backgroundColor)
                .darken(2)
                .toHexString(),
            inputTextColor: defaults.textColor,
            inputErrorPlaceholderColor: defaults.dangerColor,
            inputErrorLabelColor: defaults.dangerColor,
            inputErrorBorderColor: defaults.dangerColor,
            inputErrorBackgroundColor: TinyColor(defaults.backgroundColor)
                .darken(2)
                .toHexString(),
            inputErrorTextColor: defaults.dangerColor,
            alertMessageDefaultIconColor: defaults.textSecondaryColor,
            alertMessagePrimaryIconColor: defaults.textActiveSecondaryColor,
            alertMessageDangerIconColor: defaults.textActiveSecondaryColor,
            alertMessageWarningIconColor: defaults.textActiveSecondaryColor,
            alertMessageInfoIconColor: defaults.textActiveSecondaryColor,
            alertMessageSuccessIconColor: defaults.textActiveSecondaryColor,
            alertMessageDefaultTitleColor: defaults.textColor,
            alertMessagePrimaryTitleColor: defaults.textActiveColor,
            alertMessageDangerTitleColor: defaults.textActiveColor,
            alertMessageWarningTitleColor: defaults.textActiveColor,
            alertMessageInfoTitleColor: defaults.textActiveColor,
            alertMessageSuccessTitleColor: defaults.textActiveColor,
            alertMessageDefaultTextColor: defaults.textSecondaryColor,
            alertMessagePrimaryTextColor: defaults.textActiveSecondaryColor,
            alertMessageDangerTextColor: defaults.textActiveSecondaryColor,
            alertMessageWarningTextColor: defaults.textActiveSecondaryColor,
            alertMessageInfoTextColor: defaults.textActiveSecondaryColor,
            alertMessageSuccessTextColor: defaults.textActiveSecondaryColor,
            alertMessageDefaultBackgroundColor: defaults.defaultColor,
            alertMessagePrimaryBackgroundColor: defaults.primaryColor,
            alertMessageDangerBackgroundColor: defaults.dangerColor,
            alertMessageWarningBackgroundColor: defaults.warningColor,
            alertMessageInfoBackgroundColor: defaults.infoColor,
            alertMessageSuccessBackgroundColor: defaults.successColor,
            blurImageBackgroundColor: defaults.backgroundDarkenColor,
            blurImageOverlayBackgroundColor: TinyColor(defaults.backgroundDarkenColor)
                .setAlpha(0.3)
                .toRgbString(),
            drawerBackgroundColor: defaults.backgroundColor,
            drawerOverlayBackgroundColor: TinyColor(defaults.backgroundDarkenColor)
                .setAlpha(0.3)
                .toRgbString(),
            drawerContentBackgroundColor: defaults.backgroundSecondaryColor,
            drawerShadowColor: defaults.shadowColor,
            drawerFooterTextColor: defaults.textSecondaryColor,
            drawerFooterIconColor: defaults.textSecondaryColor,
            drawerFooterBorderColor: defaults.borderColor,
            drawerHeaderTextColor: defaults.textColor,
            drawerHeaderBackgroundColor: defaults.backgroundColor,
            drawerItemHeaderTextColor: defaults.textSecondaryColor,
            drawerItemHeaderBorderColor: defaults.borderColor,
            drawerItemTextColor: defaults.textColor,
            drawerItemIconColor: defaults.textSecondaryColor,
            drawerItemActiveTextColor: defaults.textActiveColor,
            drawerItemActiveIconColor: defaults.textActiveSecondaryColor,
            drawerItemActiveBackgroundColor: defaults.primaryColor,
            headerIconColor: defaults.textSecondaryColor,
            headerTextColor: defaults.textColor,
            headerBackgroundColor: defaults.backgroundColor,
            headerShadowColor: defaults.shadowColor,
            headerActionIconColor: defaults.primaryColor,
            modalActionItemBackgroundColor: TinyColor(defaults.backgroundDarkenColor)
                .setAlpha(0.3)
                .toRgbString(),
            modalActionItemBorderColor: defaults.borderColor,
            modalActionItemTextColor: defaults.textColor,
            modalActionItemContentBackgroundColor: defaults.backgroundSecondaryColor,
            modalItemBackgroundColor: TinyColor(defaults.backgroundDarkenColor)
                .setAlpha(0.3)
                .toRgbString(),
            modalItemBorderColor: defaults.borderColor,
            modalItemTextColor: defaults.textColor,
            modalItemContentBackgroundColor: defaults.backgroundColor,
            optionItemBorderColor: defaults.borderColor,
            optionItemIconColor: defaults.textSecondaryColor,
            optionItemTextColor: defaults.textColor,
            progressBarActiveColor: defaults.primaryColor,
            refreshControlTintColor: defaults.primaryColor,
            refreshControlColor: defaults.primaryColor,
            sliderActiveColor: defaults.primaryColor,
            sliderThumbColor: defaults.backgroundDarkenColor,
            statusBarViewBackgroundIOSColor: TinyColor(defaults.backgroundDarkenColor)
                .setAlpha(0.1)
                .toRgbString(),
            statusBarViewBackgroundAndroidColor: defaults.backgroundDarkenColor,
            switchTintColor: defaults.borderColor,
            switchOnTintColor: defaults.backgroundColor,
            switchThumbTintColor: defaults.primaryColor,
            panelShadowColor: defaults.shadowColor,
            panelIconColor: defaults.textSecondaryColor,
            panelTextColor: defaults.textColor,
            panelBackgroundColor: defaults.backgroundSecondaryColor,
            panelBorderColor: TinyColor(defaults.backgroundSecondaryColor)
                .darken(1)
                .toHexString(),
            textColor: defaults.textColor,
            titleColor: defaults.textColor
        };
    };
    return ThemeBuilder;
}());
exports.default = ThemeBuilder;
